# server_ex_1b.py
# 08.03.2023

import asyncio
import websockets

async def hello(websocket, path_str):
    print(f"websocket: {websocket}; path_str: {path_str}")
    name = await websocket.recv()
    print(f"<<< {name}")

    greeting = f"Hello {name}!"
    await websocket.send(greeting)
    print(f">>> {greeting}")

async def main():
    async with websockets.serve(hello, "", 8765):
        await asyncio.Future()

if __name__ == "__main__":
    asyncio.run(main())
