# server_ex_2.py
# 09.03.2023

import asyncio
import websockets
from functools import partial

async def hello(param_a, param_b, param_c, websocket, path_str):
    print(f"websocket: {websocket}; path_str: {path_str}\n")
    print(f"param_a: {param_a}")
    print(f"param_b: {param_b}")
    print(f"param_c: {param_c}\n")
    
    name = await websocket.recv()
    print(f"<<< {name}")

    greeting = f"Hello {name}!"
    await websocket.send(greeting)
    print(f">>> {greeting}")

async def main(param_a, param_b, param_c):
    # wrapping handler function hello() 
    wrapped_hello = partial(hello, param_a, param_b, param_c)
    async with websockets.serve(wrapped_hello, "", 8765):
        await asyncio.Future()

if __name__ == "__main__":
    
    # some params that go into the handler function
    param_a = {"pa_1": [1, 2, 3], "pa_2": "hello", "pa_c": 4711.23}
    param_b = 3543.3
    param_c = "parameter c"
    asyncio.run(main(param_a, param_b, param_c))
